#ifndef MEMORY_H
#define MEMORY_H

void *__Emalloc(int size, const char *file, int line);
void *__Erealloc(void *ptr, int size, const char *file, int line);
void *__Ecalloc(int num, int size, const char *file, int line);
void __Efree(void *ptr, const char *file, int line);
char *duplicate(char *s);

#if defined(__FILE__) && defined(__LINE__)
#define Efree(x) __Efree(x, __FILE__, __LINE__)
#define Emalloc(x) __Emalloc(x, __FILE__, __LINE__)
#define Erealloc(x, y) __Erealloc(x, y, __FILE__, __LINE__)
#define Ecalloc(x, y) __Ecalloc(x, y, __FILE__, __LINE__)        
#else
#define Efree(x) free(x)
#define Emalloc(x) malloc(x)
#define Erealloc(x, y) realloc(x, y)
#define Ecalloc(x, y) calloc(x, y)
#endif

#endif
